/*

    Meta-Environment - An environment for language prototyping.
    Copyright (C) 2000  Stichting Mathematisch Centrum, Amsterdam, The Netherlands. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    $Id: Sort.java,v 1.10 2000/04/15 15:18:44 mdejonge Exp $
*/
package nl.cwi.gipe.stred;
import toolbus.aterm.*;

public class Sort extends ATermAppl {
  public static final Sort error = new Sort("error");
  public static final String sym = "sort";

  public Sort(String str) {
    super(the_world, sym, new ATerms(the_world, new ATermAppl(the_world, str, true)));
  }

  public Sort(ATermAppl t) {
    super(the_world, sym, t.getArgs());
    if (sym.equals(t.getFun()) == false) {
	if (t.getFun().equals("iter-sep") || t.getFun().equals("iter")) {
	    this.setArgs(new ATerms(the_world,new ATermAppl(the_world,iterToString(t))));
	} else {
	    t.println(System.err);
	    System.err.println("Malformed term in sort constructor");
	    System.exit(2);
	}
    }
  }

  public String chars() {
      ATermAppl tmp = (ATermAppl) this.getArgs().getFirst();
      return tmp.getFun();
  }
    
    private String iterToString(ATermAppl t) {
	StringBuffer sb = new StringBuffer();
	ATermAppl tmp,tmp2;
	ATerms at = t.getArgs();
	while (!at.isEmpty()) {
	    tmp = (ATermAppl) at.getFirst();
	    tmp2 = (ATermAppl) tmp.getArgs().getFirst();
	    sb.append(tmp2.getFun());
	    at = at.getNext();
	}
	return new String(sb);
    }
    
    /** Returns an ATerm representation of this Sort */
    public ATermAppl toATerm() {
	return this;
    }
	
	public boolean equals(Sort s) {
		return this.chars().equals(s.chars());
	}
}
