/*

    Meta-Environment - An environment for language prototyping.
    Copyright (C) 2000  Stichting Mathematisch Centrum, Amsterdam, The Netherlands. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    $Id: Updating.java,v 1.10 2000/04/15 15:18:45 mdejonge Exp $
*/
package nl.cwi.gipe.stred;
//$Id: Updating.java,v 1.10 2000/04/15 15:18:45 mdejonge Exp $

import toolbus.aterm.*;

public class Updating {

    // The whitespace around a term replacement is kept here:
    static ATermAppl wleft = new ATermAppl(ATerm.the_world,"w");
    static ATermAppl wright = new ATermAppl(ATerm.the_world,"w");
    // This boolean states whether we have already inserted the whitespace
    // at the correct location:
    static boolean insertedWhitespaceLeft = true;
    static boolean insertedWhitespaceRight = true;
    
  // Only static methods, no constructors
  public static Editor updateEdit(ATerm t, FocusList fl, int n, int i) {
      //      SeTool.debug("In Updating.updateEdit. Args are: t: "+t.toString()+", fl: "+fl.toString()+", n: "+Integer.toString(n)+", i: "+Integer.toString(i));
SeTool.debug("fl: "+fl.toString());
    FocusList fl1 = new Editor(t, fl).currentFocus(n);
SeTool.debug("fl1: "+fl1.toString());
    //    SeTool.debug("Made current focus");
    ATerm t2 = updAnno(t, fl1.head().getPath(), i);
SeTool.debug("fl1: "+fl1.toString());
    //    SeTool.debug("Updated annotation");
    FocusList fl2 = updFocus(fl1,n,i);
    //    SeTool.debug("Updated focus");
    // Set the status of this focus to dirty.
SeTool.debug("fl2: "+fl2.toString());
    fl2.head().setDirty();
SeTool.debug("fl2: "+fl2.toString());
    return new Editor(t2,fl2);
  }

  public static Editor updateEdit(ATerm t, FocusList fl, int n)  {
    return updateEdit(t,fl,n,-1);
  }

  static FocusList updFocus(FocusList fl, int n, int i) {
      FocusList result;
      //SeTool.debug("In Updating.updFocus. Args are: fl: "+fl.toString()+", n: "+Integer.toString(n)+", i: "+Integer.toString(i));
    if (fl.empty()) {
      return fl;
    } else {
      Focus f = fl.head();
      fl.tail();
      if (f.after(n)) {
	  result = updFocus(fl,n,i);
	  result.insertHead(f);
	return result;
      } else {
	Area a = f.getArea();
	if (f.in(n)) {
	  int n1 = a.length();
	  Area a2 = a.setLength(n1+i);
	  f.setArea(a2);
	  result = updFocus(fl,n,i);
	  result.insertHead(f);
	  return result;
	} else { // if (f.before(n)) {
	  int n1 = a.start();
	  Area a3 = a.setStart(n1+i);
	  f.setArea(a3);
	  result = updFocus(fl,n,i);
	  result.insertHead(f);
	  return result;
	}
      }
    }
  }

    public static ATerm updTerm(ATerm t1, Path p, ATerm t2) {
	//      SeTool.debug("In updTerm. t1 = "+t1.toString()+",\n\n\n p = "+p.toString()+",\n\n\n t2 = "+t2.toString());
    AFun args = new AFun(ATerm.the_world,"args");
    AFun elems = new AFun(ATerm.the_world,"elems");
    AFun term = new AFun(ATerm.the_world,"term");
    ATerm ut;
    if (t1.getType() == ATerm.LIST) {
      // t1 is a list
      ATermList t3 = (ATermList) t1;
      if (p.headZero()) {
	ATerms tmp = t3.getATerms();
	//	SeTool.debug("\n\nThis is what tmp looks like: "+tmp.toString());
	ATerm first = tmp.getFirst();
	//	SeTool.debug("\n\nThis is what first looks like: "+first.toString());
	ATerm tmp2 = updTerm(first,p,t2);
	// Assume that wleft is always empty here. Has to do with the way 
	// we calculate the focus.
	
	    
	//	SeTool.debug("\n\nThis is what tmp2 looks like: "+tmp2.toString());
      	tmp.setFirst(tmp2);
	if (!insertedWhitespaceRight) {
	    // Then if tmp is longer than 2 we have to set wright to 
	    // tmp.getNext().getFirst().
	    // and set insertedWhitespace to true
	    if (tmp.length() > 2) {
		ATermAppl tmpws = (ATermAppl) tmp.getNext().getFirst();
		tmpws = (ATermAppl) wConc(wright,tmpws);
		tmpws = (ATermAppl) PositionInformation.annotate(tmpws);
		tmp = new ATerms(ATerm.the_world,tmp.getFirst(), new ATerms(ATerm.the_world,tmpws, tmp.getNext().getNext()));
		insertedWhitespaceRight = true;
	    }
	}
	t3.setATerms(tmp);
	//	SeTool.debug("\n\nThis is t3 when headzero: "+t3.toString());
	return t3;
      } else if (p.isLeafPath()) {
      	ATerms tmp = t3.getATerms();
	tmp.setFirst(t2);
	t3.setATerms(tmp);
	//	SeTool.debug("This is t3: "+t3.toString());
	return t3;
      } else {
      	p.decreaseHead();
      	ATerm tmp = updTerm(new ATermList(ATerm.the_world,t3.getATerms().getNext()), p, t2);
	ATermAppl currHead = (ATermAppl) t3.getATerms().getFirst();
	if (!insertedWhitespaceLeft) {
	    if (currHead.getFun().equals("w")) {
		currHead = (ATermAppl) wConc(currHead,wleft);
		currHead = (ATermAppl) PositionInformation.annotate(currHead);
		insertedWhitespaceLeft = true;
	    }
	}
      	if (tmp.getType() == ATerm.LIST) {
	  ATermList tmp2 = (ATermList) tmp;
	  return new ATermList(ATerm.the_world,new ATerms(ATerm.the_world,currHead,tmp2.getATerms()));
	} else {
	  return new ATermList(ATerm.the_world,new ATerms(ATerm.the_world,currHead, new ATerms(ATerm.the_world,tmp)));
	}
      }
    } else {
	//      SeTool.debug("t1 is not a list");
      if (p.isLeafPath()) {
	return t2;
      } else if (p.headZero()) {
	ATermAppl t4 = (ATermAppl) t1;
	if (t4.getFun().equals("appl")) {
	  //	  SeTool.debug("Is the anno still in t4: "+t4.toString()+" before");
	  t4 = AsFix.repl(t4, args, updTerm(AsFix.acc(t4,args),p.tail(),t2));
	  //	  SeTool.debug("and after replacement: "+t4.toString());
	  return t4;
	} else if (t4.getFun().equals("list")){
	  t4 = AsFix.repl(t4, elems, updTerm(AsFix.acc(t4,elems),p.tail(),t2));
	  return t4;
	} else if (t4.getFun().equals("term")) {
	    Path pp = p.tail();
	    pp.decreaseHead();
	    ut = updTerm(AsFix.acc(t4,term),pp,t2);
	    t4 = AsFix.repl(t4, term, ut);
	    if (!insertedWhitespaceLeft) {
		AFun w_left = new AFun(ATerm.the_world,"w-left");
		ATerm w1 = AsFix.acc(t4,w_left);
		w1 = Updating.wConc(wleft,w1);
		t4 = AsFix.repl(t4,w_left,w1);
		insertedWhitespaceLeft = true;
	    }
	    if (!insertedWhitespaceRight) {
		AFun w_right = new AFun(ATerm.the_world,"w-right");
		ATerm w2 = AsFix.acc(t4,w_right);
		w2 = Updating.wConc(wright,w2);
		t4 = AsFix.repl(t4,w_right,w2);
		insertedWhitespaceRight = true;
	    }
	    return t4;
	}
      }
    }
    System.err.println("Error in Updating.updTerm");
    System.exit(2);
    return null; // Duh!
  }
  
    public static ATerm updAnno(ATerm t, Path p, int i) {
      Path p2 = new Path().right(); // This is for the top "term" asfix term.
      //      SeTool.debug(p2.toString());
      //      SeTool.debug(p.toString());
      try {
	  if (p.isLeafPath() || p.equals(p2)) {
	      return updTerm(t,p,PositionInformation.addToLen(Subtree.subtree(t,p),i));
	  } else {
	      ATerm t2 = PositionInformation.addToLen(Subtree.subtree(t,p),i);
	      return updTerm(updAnno(t,p.up(),i), p,t2);
	  }
      }
      catch (SubtreeException e) {
	  System.err.println(e);
	  System.err.println("In Updating.updAnno");
	  System.exit(2);
      }
      return null;
  }

    static private ATerm wConc(ATerm t1, ATerm t2) {
	ATerm result = null;
	ATermAppl w1 = (ATermAppl) t1;
	ATermAppl w2 = (ATermAppl) t2;
	String s1 = ((ATermAppl) w1.getArgs().getFirst()).getFun();
	String s2 = ((ATermAppl) w2.getArgs().getFirst()).getFun();
	try {
	    result = ATerm.the_world.makeSimple("w(\""+s1+s2+"\")");
	}
	catch (ParseError e) {
	    System.err.println(e);
	    System.exit(2);
	}
	return result;
    }
	
}


